<?php

namespace Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for listPaymentMethodsSuccess StructType
 * @subpackage Structs
 * @Comment This is an automatically generated Docdata PHP SDK
 * @Version 1.3
 * @Date 2017/01/17
 * @Time 13-26
 */
class ListPaymentMethodsSuccess extends AbstractStructBase
{
    /**
     * The success
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Docdata\StructType\Success
     */
    public $success;
    /**
     * The paymentMethod
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Docdata\StructType\PaymentMethod[]
     */
    public $paymentMethod;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for listPaymentMethodsSuccess
     * @uses ListPaymentMethodsSuccess::setSuccess()
     * @uses ListPaymentMethodsSuccess::setPaymentMethod()
     * @uses ListPaymentMethodsSuccess::setAny()
     * @param \Docdata\StructType\Success $success
     * @param \Docdata\StructType\PaymentMethod[] $paymentMethod
     * @param \DOMDocument $any
     */
    public function __construct(\Docdata\StructType\Success $success = null, array $paymentMethod = array(), \DOMDocument $any = null)
    {
        $this
            ->setSuccess($success)
            ->setPaymentMethod($paymentMethod)
            ->setAny($any);
    }
    /**
     * Get success value
     * @return \Docdata\StructType\Success
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param \Docdata\StructType\Success $success
     * @return \Docdata\StructType\ListPaymentMethodsSuccess
     */
    public function setSuccess(\Docdata\StructType\Success $success = null)
    {
        $this->success = $success;
        return $this;
    }
    /**
     * Get paymentMethod value
     * @return \Docdata\StructType\PaymentMethod[]|null
     */
    public function getPaymentMethod()
    {
        return $this->paymentMethod;
    }
    /**
     * Set paymentMethod value
     * @throws \InvalidArgumentException
     * @param \Docdata\StructType\PaymentMethod[] $paymentMethod
     * @return \Docdata\StructType\ListPaymentMethodsSuccess
     */
    public function setPaymentMethod(array $paymentMethod = array())
    {
        foreach ($paymentMethod as $listPaymentMethodsSuccessPaymentMethodItem) {
            // validation for constraint: itemType
            if (!$listPaymentMethodsSuccessPaymentMethodItem instanceof \Docdata\StructType\PaymentMethod) {
                throw new \InvalidArgumentException(sprintf('The paymentMethod property can only contain items of \Docdata\StructType\PaymentMethod, "%s" given', is_object($listPaymentMethodsSuccessPaymentMethodItem) ? get_class($listPaymentMethodsSuccessPaymentMethodItem) : gettype($listPaymentMethodsSuccessPaymentMethodItem)), __LINE__);
            }
        }
        $this->paymentMethod = $paymentMethod;
        return $this;
    }
    /**
     * Add item to paymentMethod value
     * @throws \InvalidArgumentException
     * @param \Docdata\StructType\PaymentMethod $item
     * @return \Docdata\StructType\ListPaymentMethodsSuccess
     */
    public function addToPaymentMethod(\Docdata\StructType\PaymentMethod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Docdata\StructType\PaymentMethod) {
            throw new \InvalidArgumentException(sprintf('The paymentMethod property can only contain items of \Docdata\StructType\PaymentMethod, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->paymentMethod[] = $item;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \Docdata\StructType\ListPaymentMethodsSuccess::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \Docdata\StructType\ListPaymentMethodsSuccess
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Docdata\StructType\ListPaymentMethodsSuccess
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
